#!/usr/bin/awk

function escsquot(s) {
    gsub(/'/,"'\\''",s);
    return s;
}

function escmake(s) {
    gsub(/'/,"'\\''",s);
    gsub(/\$/,"$$",s);
    return s;
}

function rundeps(dir,env) {
    if (dir in rdp) return;
    rdp[dir]=dir;
    cmd="'"escsquot(RUNMAKE)"' rdep '"escsquot(PORTSDIR)"' '"escsquot(dir)"' '"escsquot(env)"' '"escsquot(ra[dir])"' 'run-depends-list' '"escsquot(b[dir])"' '"escsquot(a[dir])"'";
    print cmd >>"/dev/stderr";
    n="";
    while ((cmd|getline n)==1) {
        sub("^"PORTSDIR"/","",n);
        if (n in ps) n=ps[n];
        print "\t"n >>"/dev/stderr";
        rd[dir":"n]=n;
        rp[n]=n;
        re[n]=(re[n]=="") ? env : ((env=="") ? re[n] : env" "re[n]);
    }
    close(cmd);
    if (!n) return;
    for (n in rp) rundeps(n,env);
}

function buildeps (dir,env) {
    if (dir in bdp) return;
    bdp[dir]=dir;
    cmd="'"escsquot(RUNMAKE)"' bdep '"escsquot(PORTSDIR)"' '"escsquot(dir)"' '"escsquot(env)"' '"escsquot(ra[dir])"' 'build-depends-list"
    if (!(dir in rp)) cmd=cmd" run-depends-list|sort|uniq";
    cmd=cmd"' '"escsquot(b[dir])"' '"escsquot(a[dir])"'";
    print cmd >>"/dev/stderr";
    n="";
    while ((cmd|getline n)==1) {
        sub("^"PORTSDIR"/","",n);
        if (n in ps) n=ps[n];
        print "\t"n >>"/dev/stderr";
        bd[dir":"n]=n;
        bp[n]=n;
        be[n]=(be[n]=="") ? env : ((env=="") ? be[n] : env" "be[n]);
    }
    close(cmd);
    if (!n) return;
    for (n in bp) buildeps(n,env);
}

BEGIN {
    FS=":";
    first=1;
}
(first) {
    if (!PORTSDIR) PORTSDIR="/usr/ports";
    if (!RUNMAKE) RUNMAKE="./run-make";
    if (!RUNMODE) RUNMODE="pkg";
    if (!RTARGET) RTARGET="package";
    if (!BTARGET) BTARGET="install";
    if (!PORTSUBST) PORTSUBST=".portsubst";
    while ((getline n <PORTSUBST)==1) {
        if (n~/^#/ || n~/^$/) continue;
        split(n,a,/:/);
        ps[a[1]]=a[2];
    }
    close(PORTSUBST);
    print "PORTSDIR?="PORTSDIR;
    print "RUNMAKE?="RUNMAKE;
    print "RUNMODE?="RUNMODE;
    print "RTARGET?="RTARGET;
    print "BTARGET?="BTARGET;
    print "";
    printf "all:";
    first=0;
}
/^#/ || /^$/ {
    next;
}
{
    nn=$1;
    gsub(/\//,"%",nn);
    printf " \\\n\t\t%s",nn;
    rp[$1]=$1;
    b[$1]=$2;
    re[$1]=$3;
    ra[$1]=$4;
    a[$1]=$5;
    #rundeps($1,$3);
}
END {
    for (n in rp) rundeps(n,re[n]);
    for (n in rp) buildeps(n,re[n]);
    for (n in rp) delete bp[n];
    for (dn in rd) delete bd[dn];
    print "\n\n\n# run depends"
    for (n in rp) {
        nn=n;
        gsub(/\//,"%",nn);
        rn="^"n":";
        gsub(/\+/,"\\+",rn);
        printf "\n%s:",nn;
        for (dn in rd) {
            if (match(dn,rn)) {
                sub(rn,"",dn);
                gsub(/\//,"%",dn);
                printf " \\\n\t\t%s",dn;
            }
        }
        for (dn in bd) {
            if (match(dn,rn)) {
                sub(rn,"",dn);
                gsub(/\//,"%",dn);
                printf " \\\n\t\t%s",dn;
            }
        }
        print "\n\t@-${RUNMAKE} '${RUNMODE}' '${PORTSDIR}' '"escmake(n)"' '"escmake(re[n])"' '"escmake(ra[n])"' '${RTARGET}' '"escmake(b[n])"' '"escmake(a[n])"' \\";
        print "\t&& touch '"nn"'";
    }
    print "\n\n# build depends"
    for (n in bp) {
        nn=n;
        gsub(/\//,"%",nn);
        printf "\n%s:",nn;
        for (dn in rd) {
            if (match(dn,"^"n":")) {
                sub("^"n":","",dn);
                gsub(/\//,"%",dn);
                printf " \\\n\t\t%s",dn;
            }
        }
        for (dn in bd) {
            if (match(dn,"^"n":")) {
                sub("^"n":","",dn);
                gsub(/\//,"%",dn);
                printf " \\\n\t\t%s",dn;
            }
        }
        print "\n\t@-${RUNMAKE} '${RUNMODE}' '${PORTSDIR}' '"escmake(n)"' '"escmake(re[n])"' '"escmake(ra[n])"' '${BTARGET}' '"escmake(b[n])"' '"escmake(a[n])"' \\";
        print "\t&& touch '"nn"'";
    }
}
