#!/usr/bin/awk

BEGIN {
    FS=":";
    first=1;
}
(first) {
    if (!PORTSDIR) PORTSDIR="/usr/ports";
    if (!INDEX) INDEX=PORTSDIR"/INDEX-8";
    if (!IDXPDIR) IDXPDIR=PORTSDIR;
    while ((getline n <INDEX)==1) {
        split(n,a,/\|/);
        sub("^"IDXPDIR"/","",a[2]);
        idx[a[1]]=a[2];
    }
    close(INDEX);
    first=0;
}
/^#/ || /^$/ {
    next;
}
{
    p=$1;
    if (!match(p,/\//)) {
        c=0;
        delete a;
        for (n in idx) if (match(n,"^"p)) a[c++]=n;
        if (c==0) {
            print "no packages for /^"p"/" >>"/dev/stderr";
            next;
        }
        if (c>1) {
            print "too many packages for /^"p"/" >>"/dev/stderr";
            for (n in a) print "  "a[n]": "idx[a[n]] >>"/dev/stderr";
            next;
        }
        p=idx[a[0]];
    }
    gsub(/\/+/,"/",p);
    sub(/\/$/,"",p);
    print p":"$2":"$3":"$4":"$5;
}
